<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Global Symbol Table</TITLE>
<link href="suif1_43.html" rel=Next>
<link href="suif1_41.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_41.html">previous</A>, <A HREF="suif1_43.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC42" HREF="suif1_toc.html#TOC42">The Global Symbol Table</A></H3>
<P>
<A NAME="IDX265"></A>
<A NAME="IDX266"></A>

</P>
<P>
The global symbol table is at the top of the symbol table hierarchy and
corresponds to the outermost global scope.  It contains objects that are
visible across source files (i.e. shared types and global symbols with
external linkage).  For this reason, it is associated with the
<CODE>file_set</CODE> object.  See section <A HREF="suif1_8.html#SEC8">The File Set</A>.

</P>
<P>
The advantage of using a shared global symbol table appears when
performing interprocedural analyses and transformations.  Without a
common symbol table, it can be quite a burden to deal with references to
symbols that are defined in some files but not in others.  Even trying
to determine which symbols from different files correspond to the same
objects is difficult.  In essence, each interprocedural pass would need
to do the work of a linker!  The shared global symbol table avoids all
of these problems and makes interprocedural optimization relatively
easy.

</P>
<P>
Along with the benefits of the global symbol table come a few
difficulties.  Sharing the global symbol table across files makes it
difficult to support separate compilation.  Each file must contain a
copy of the global symbol table, and if these files are manipulated
individually, their copies of the global symbol table will not be
consistent.  Thus, before a group of files can be combined in a SUIF
file set, their global symbol tables must be "linked" together using
the SUIF linker pass.  Whether this is preferable to just combining all
of the source files into one big SUIF file is debatable.

</P>
<P>
<A NAME="IDX267"></A>
The <CODE>global_symtab</CODE> class is used to represent the global symbol
table.  It is also used as the base class for file symbol tables.
Because procedure symbols may only be entered in global and file symbol
tables, this class contains the methods to deal with them.  The
<CODE>new_proc</CODE> method creates a new procedure symbol and enters it in
the table (see section <A HREF="suif1_48.html#SEC48">Creating New Entries</A>), and the <CODE>lookup_proc</CODE>
method searches for an existing procedure symbol (see section <A HREF="suif1_47.html#SEC47">Lookup Methods</A>).  The <CODE>number_globals</CODE> method in this class handles the
task of assigning ID numbers to the symbols and types in global and file
symbol tables (see section <A HREF="suif1_50.html#SEC50">Numbering Types and Symbols</A>).

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_41.html">previous</A>, <A HREF="suif1_43.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
